// CPanelDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CPanelDemo.h"
#include "CPanelDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCPanelDemoDlg dialog

CCPanelDemoDlg::CCPanelDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCPanelDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCPanelDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	cCurrentColor = 0x000000FF;
	nMaxLayer = 0;
}

void CCPanelDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCPanelDemoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCPanelDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CCPanelDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_COLORBUTTON, OnColorbutton)
	ON_NOTIFY(UDN_DELTAPOS, IDC_BOTTOMSPIN, OnDeltaposBottomspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_RIGHTSPIN, OnDeltaposRightspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_TOPSPIN, OnDeltaposTopspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_LEFTSPIN, OnDeltaposLeftspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_LAYERSPIN, OnDeltaposLayerspin)
	ON_BN_CLICKED(IDC_ADDLAYER, OnAddlayer)
	ON_BN_CLICKED(IDC_REMOVELAYER, OnRemovelayer)
	ON_BN_CLICKED(IDC_REMOVEALL, OnRemoveall)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCPanelDemoDlg message handlers

BOOL CCPanelDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	BOOL result = ColorBox.SubclassDlgItem (IDC_COLORBOX, this);
	ASSERT (result);

	MainCustomBorder.SubclassDlgItem (IDC_STATICMAIN, this);
	MainCustomBorder.Apply3DStyle (1, TRUE);
	CheckRadioButton (IDC_RADIO1, IDC_RADIO6, IDC_RADIO2);

	BottomSpin = (CSpinButtonCtrl*)GetDlgItem (IDC_BOTTOMSPIN);
	TopSpin = (CSpinButtonCtrl*)GetDlgItem (IDC_TOPSPIN);
	LeftSpin = (CSpinButtonCtrl*)GetDlgItem (IDC_LEFTSPIN);
	RightSpin = (CSpinButtonCtrl*)GetDlgItem (IDC_RIGHTSPIN);
	LayerSpin = (CSpinButtonCtrl*)GetDlgItem (IDC_LAYERSPIN);

	LayerSpin->SetRange (0, 0);
	LayerSpin->SetPos (0);
	BottomSpin->SetRange (0, 100);
	BottomSpin->SetPos (0);
	TopSpin->SetRange (0, 100);
	TopSpin->SetPos (0);
	LeftSpin->SetRange (0, 100);
	LeftSpin->SetPos (0);
	RightSpin->SetRange (0, 100);
	RightSpin->SetPos (0);


	result = OwnBorder.SubclassDlgItem (IDC_STATIC, this);
	OwnBorder.Apply3DStyle (0, TRUE);
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCPanelDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCPanelDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCPanelDemoDlg::OnColorbutton() 
{
	// TODO: Add your control notification handler code here
//	ColorDialog.SetCurrentColor (cCurrentColor);
	if (ColorDialog.DoModal () == IDOK)
	{
		cCurrentColor = ColorDialog.GetColor ();
		ColorBox.currentcolor = cCurrentColor;
		ColorBox.Invalidate ();
	}
	OwnBorder.SetBorderLayer (LayerSpin->GetPos (), LeftSpin->GetPos (), TopSpin->GetPos (), RightSpin->GetPos (), BottomSpin->GetPos (), cCurrentColor);

}

void CCPanelDemoDlg::OnDeltaposBottomspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	if (pNMUpDown->iPos+pNMUpDown->iDelta >= 0)
	OwnBorder.SetBorderLayer (LayerSpin->GetPos (), LeftSpin->GetPos (), TopSpin->GetPos (), RightSpin->GetPos (), pNMUpDown->iPos+pNMUpDown->iDelta, cCurrentColor);
	
	*pResult = 0;
}



void CCPanelDemoDlg::OnDeltaposRightspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	if (pNMUpDown->iPos+pNMUpDown->iDelta >= 0)
	OwnBorder.SetBorderLayer (LayerSpin->GetPos (), LeftSpin->GetPos (), TopSpin->GetPos (), pNMUpDown->iPos+pNMUpDown->iDelta, BottomSpin->GetPos (), cCurrentColor);
	
	*pResult = 0;
}


void CCPanelDemoDlg::OnDeltaposTopspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	if (pNMUpDown->iPos+pNMUpDown->iDelta >= 0)
	OwnBorder.SetBorderLayer (LayerSpin->GetPos (), LeftSpin->GetPos (), pNMUpDown->iPos+pNMUpDown->iDelta, RightSpin->GetPos (), BottomSpin->GetPos (), cCurrentColor);
	
	*pResult = 0;
}

void CCPanelDemoDlg::OnDeltaposLeftspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	if (pNMUpDown->iPos+pNMUpDown->iDelta >= 0)
	OwnBorder.SetBorderLayer (LayerSpin->GetPos (), pNMUpDown->iPos+pNMUpDown->iDelta, TopSpin->GetPos (), RightSpin->GetPos (), BottomSpin->GetPos (), cCurrentColor);
	
	*pResult = 0;
}

void CCPanelDemoDlg::OnDeltaposLayerspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	int nTopWidth, nLeftWidth, nRightWidth, nBottomWidth;
	// TODO: Add your control notification handler code here

	if (((pNMUpDown->iPos+pNMUpDown->iDelta) <= nMaxLayer) && (pNMUpDown->iPos+pNMUpDown->iDelta>=0))
	{
		cCurrentColor = OwnBorder.GetBorderLayer (pNMUpDown->iPos+pNMUpDown->iDelta, nLeftWidth, nTopWidth, nRightWidth, nBottomWidth);
		BottomSpin->SetPos (nBottomWidth);
		TopSpin->SetPos (nTopWidth);
		LeftSpin->SetPos (nLeftWidth);
		RightSpin->SetPos (nRightWidth);
		ColorBox.currentcolor = cCurrentColor;
		ColorBox.Invalidate ();
	
		OwnBorder.SetBorderLayer (pNMUpDown->iPos+pNMUpDown->iDelta, LeftSpin->GetPos (), TopSpin->GetPos (), RightSpin->GetPos (), BottomSpin->GetPos (), cCurrentColor);
	}
	
	*pResult = 0;
}

void CCPanelDemoDlg::OnAddlayer() 
{
	// TODO: Add your control notification handler code here
	nMaxLayer++;
	OwnBorder.SetBorderLayer (nMaxLayer, 0, 0, 0, 0, cCurrentColor);	
	ZeroSpins ();
	
	LayerSpin->SetRange (0, nMaxLayer);
	LayerSpin->SetPos (nMaxLayer);
}

void CCPanelDemoDlg::OnRemovelayer() 
{
	// TODO: Add your control notification handler code here
	OwnBorder.DeleteBorderLayer (LayerSpin->GetPos ());
	ZeroSpins ();
}

void CCPanelDemoDlg::OnRemoveall() 
{
	// TODO: Add your control notification handler code here
	OwnBorder.DeleteBorderLayer (-1);
	ZeroSpins ();
	LayerSpin->SetPos (0);
	LayerSpin->SetRange (0, 0);
	nMaxLayer = 0;
}

void CCPanelDemoDlg::ZeroSpins()
{
	TopSpin->SetPos (0);
	BottomSpin->SetPos (0);
	LeftSpin->SetPos (0);
	RightSpin->SetPos (0);
}

void CCPanelDemoDlg::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	MainCustomBorder.Apply3DStyle (0, TRUE);
}

void CCPanelDemoDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	MainCustomBorder.Apply3DStyle (1, TRUE);
}

void CCPanelDemoDlg::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	MainCustomBorder.Apply3DStyle (2, TRUE);
}

void CCPanelDemoDlg::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	MainCustomBorder.Apply3DStyle (3, TRUE);
}

void CCPanelDemoDlg::OnRadio5() 
{
	// TODO: Add your control notification handler code here
	MainCustomBorder.Apply3DStyle (4, TRUE);
}

void CCPanelDemoDlg::OnRadio6() 
{
	// TODO: Add your control notification handler code here
	MainCustomBorder.DeleteBorderLayer ();
	int layer = MainCustomBorder.GetNumBorderLayers ();
	MainCustomBorder.SetBorderLayer (layer, 0, 0, 2, 2, 0x000000FF);
	MainCustomBorder.SetBorderLayer (layer + 1, 0, 2, 2, 0, 0x00C0C0C0);
	MainCustomBorder.SetBorderLayer (layer + 2, 2, 2, 0, 0, 0x000000FF);
	MainCustomBorder.SetBorderLayer (layer + 3, 2, 0, 0, 2, 0x00C0C0C0);
	MainCustomBorder.SetBorderLayer (layer + 4, 0, 0, 2, 2, 0x000000FF);
	MainCustomBorder.SetBorderLayer (layer + 5, 0, 2, 2, 0, 0x00C0C0C0);
	MainCustomBorder.SetBorderLayer (layer + 6, 2, 2, 0, 0, 0x000000FF);

}

